/*
 * Demo-Source-Skeletton (and GPN10-Talk!)
 *
 * By urs / mercury <urs@nerd2nerd.org>
 *
 * Sorry for the wild mixture of german and english comments.
 */
#define IMG_LOAD
#define MIPMAP
#define G_WIDTH 1024
#define G_HEIGHT 768
#define G_BPP 32

#include "shaders.h"
#include "framework.h"


/* Windows needs this. Whatever. */
int _fltused=1;

/* bg */
static const TexturedVertexData3D square_vertices[] = {
	{ {-1.,-1.,0.}, {0.,0.,-1}, {0.,0.} },
	{ {1.,-1.,0.}, {0.,0.,-1}, {1.,0.} },
	{ {1.,1.,0.}, {0.,0.,-1}, {1.,1.} },
	{ {-1.,1.,0.}, {0.,0.,-1}, {0.,1.} },
};

/* Sliding fontzeug */
static const TexturedVertexData3D font_halves[] = {
	{ {-1.,-1.,0.}, {1.,0.,0}, {0.,1.} },
	{ {1.,-1.,0.}, {1.,0.,0}, {1.,1.} },
	{ {1.,0.,0.}, {1.,0.,0}, {1.,.5} },
	{ {-1.,0.,0.}, {1.,0.,0}, {0.,.5} },
	{ {-1.,0.,0.}, {-1.,0.,0}, {0.,.5} },
	{ {1.,0.,0.}, {-1.,0.,0}, {1.,.5} },
	{ {1.,1.,0.}, {-1.,0.,0}, {1.,0.} },
	{ {-1.,1.,0.}, {-1.,0.,0}, {0.,0.} },
};

/* Für die shadowmaps */
static const float cube[] = { -1,-1,-1,	1,-1,-1,	1,1,-1,		-1,1,-1,
	-1,-1,-1,	-1,1,-1,	-1,1,1,		-1,-1,1,
	-1,-1,-1,	-1,-1,1,	1,-1,1,		1,-1,-1,

	1,1,1,	1,-1,1,		-1,-1,1,	-1,1,1,
	1,1,1,	1,1,-1,		1,-1,-1,	1,-1,1,
	1,1,1,	-1,1,1,		-1,1,-1,	1,1,-1,
};


#define N_PARTICLES 4096
static float *particles;

static unsigned int bg_vbo, particle_vbo,bg_shader, bobbel_shader;
static unsigned int postprocess_texture, postprocess_shader;
static unsigned int font_halves_vbo, font_slide_shader;
static unsigned int title_texture;
static unsigned int cube_vbo, inner_shader, outer_shader, cubemap;
static unsigned int t,t0;
static unsigned int strobotime=0;


/* Presentation-Slide-Textures */
#define N_SLIDES 22
static unsigned int slide_tex[N_SLIDES];

static void __small__ postprocess() {
	/* Copy to texture */
	glDisable(GL_CULL_FACE);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
	copy_to_texture(postprocess_texture);

	/* Postprocess */
	flat();
	glUseProgram(postprocess_shader);
	draw_vbo(GL_QUADS, bg_vbo,4);
	glUseProgram(0);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
}

/* Toller bunter Hintergrund */
void __small__ draw_bg() {
	int color1, color2, t_uniform;
	glUseProgram(bg_shader);
	color1 = glGetUniformLocation(bg_shader, "col1");
	color2 = glGetUniformLocation(bg_shader, "col2");
	t_uniform = glGetUniformLocation(bg_shader, "time");

	//if(t>6000 && t < 84000) {
	//	glUniform1f(t_uniform, (float)t*.00133);
	//} else {
	if(t-strobotime*.00133f < 1.f) {
		glUniform1f(t_uniform, t-strobotime*.00133);
	} else {
		glUniform1f(t_uniform, 0);
	}
	//}
	glUniform4f(color1, 1.f,.8f,.3f,1.f);
	glUniform4f(color2, .2f,.2f,.8f,1.f);

	draw_vbo(GL_QUADS, bg_vbo,4);
}

/* Partikel und Sterne */
void __small__ update_and_draw_particles() {
	int i,t_uniform;
	glBindBuffer(GL_ARRAY_BUFFER, particle_vbo);
	particles = glMapBuffer(GL_ARRAY_BUFFER,GL_READ_WRITE);
	for(i=0; i<N_PARTICLES; i++) {
		particles[6*i]+=particles[6*i+3];
		if(particles[6*i]>1000) particles[6*i]-=2000;
		if(particles[6*i]<-500) particles[6*i]+=2000;
		particles[6*i+1]+=particles[6*i+4];
		if(particles[6*i+1]>500) particles[6*i+1]-=2000;
		if(particles[6*i+1]<-500) particles[6*i+1]+=2000;
		particles[6*i+2]+=0.f;
		particles[6*i+3]+=0.f;
		particles[6*i+4]+=0.f;
		particles[6*i+5]+=0.f;
	}
	glUnmapBuffer(GL_ARRAY_BUFFER);

	glUseProgram(bobbel_shader);
	t_uniform = glGetUniformLocation(bobbel_shader, "time");
	glUniform1f(t_uniform,(float)t*.00133);
	
	/* Und Zeichnen. */
	glEnable(GL_BLEND);
	glDepthMask(0);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glEnableClientState(GL_VERTEX_ARRAY);
	glEnableClientState(GL_NORMAL_ARRAY);

	glVertexPointer(3, GL_FLOAT, 6*sizeof(float), 0);
	glNormalPointer(GL_FLOAT, 6*sizeof(float), sizeof(float)*3);
	glDrawArrays(GL_POINTS, 0, N_PARTICLES);

	glDisableClientState(GL_VERTEX_ARRAY);
	glDisableClientState(GL_NORMAL_ARRAY);
	glDepthMask(1);
	glDisable(GL_BLEND);
}

void glide_in_font(float target_time) {

	int i;

	glPushMatrix();
	glTranslatef(0,0,40.f);
	glScalef(300.,300.,300.);
	glUseProgram(font_slide_shader);
	i = glGetUniformLocation(font_slide_shader, "time");
  glUniform1f(i,sin(.0001f*(t-target_time)));
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	draw_vbo(GL_QUADS,font_halves_vbo,8);
	glDisable(GL_BLEND);
	glPopMatrix();
}

/* Load Slides (data/slideXY.png) as textures */
void init_slides() {
	int i;
	char temp[20];
	for(i=0; i<N_SLIDES; i++) {
		snprintf(temp,19,"data/slide%i.png",i);
		slide_tex[i]=load_texture(temp);
	}
}

/* Draw a slide as a 2d foreground texture */
void draw_slide(int num) {
	glPushMatrix();
	flat();
	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,slide_tex[num]);
	glUseProgram(0);
	draw_vbo(GL_QUADS,font_halves_vbo,8);
	glEnable(GL_DEPTH_TEST);
	glPopMatrix();
}

/* Bobbly bobbles. They Bobble.*/
void bobble_scene() {
		glClearDepth(4000.f);
		glClearColor(0.,0.,0.,1.f);
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glFrustum(-0.6f,0.6f,-0.45f,0.45f,1.f,4000.f);
		glRotatef(14.f-5.f*sin((t-3000.f)*.0003f),0,1.f,0);
		glRotatef(-7.f+5.f*cos((t-3000.f)*.0003f),1.f,0,0);
		glRotatef(30.f-sin(t*.0003f),0.f,0.f,1.f);
		glTranslatef(100,0,-800.f);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();

		/* Render Background */
		glPushMatrix();
		glScalef(10000.f,900.f,0);
		glDepthMask(0);
		draw_bg();
		glDepthMask(1);
		glPopMatrix();

		/* Render particles */
		update_and_draw_particles();

}

/* würfel wirft Schatten an Wände, news at 11! */
void shadowmap_scene() {
	float matrix[16];
	static float phi=0;
	static float theta=10.f;
	int i;

	phi+=0.5;

	/* Clear */
	glClearDepth(200.f);
	glClearColor(0,0,0,1);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glBindTexture(GL_TEXTURE_CUBE_MAP,cubemap);

	/* Save cube rotation matrix */
	glLoadIdentity();
	glRotatef(theta,1.0,0,0);
	glRotatef(phi,0,1.0,0);
	glGetFloatv(GL_MODELVIEW_MATRIX,matrix);

	/* Transform to viewpoint */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1,1,-0.75,0.75,1.,2600);
	glTranslatef(0,0,-70);
	glRotatef(theta,1.0,0,0);
	glRotatef(phi,0,1.0,0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	/* Inneren würfel malen */
	glColor3f(1.f,1.f,0.8f);
	glPushMatrix();
	glUseProgram(inner_shader);
	glTranslatef(30*sin(t/500.),15*cos(t/1000.),25*cos(t/1500.1));
	glRotatef(theta,1.0,0,0);
	glRotatef(phi,0,1.0,0);

	glBindBuffer(GL_ARRAY_BUFFER, cube_vbo);
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3,GL_FLOAT, 3*sizeof(float), 0);
	glDrawArrays(GL_QUADS, 0, 6*4);
	glDisableClientState(GL_VERTEX_ARRAY);
	glPopMatrix();

	/* Gut knut. Jetzt nochmal drehen, und in Größer aussenrum zeichnen. */
	glEnable(GL_TEXTURE_CUBE_MAP);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);
	glUseProgram(outer_shader);
	i=glGetUniformLocation(outer_shader,"lightpos");
	glUniform4f(i,30*sin(t/500.),15*cos(t/1000.),25*cos(t/1500.1),1);
	i=glGetUniformLocation(outer_shader,"rotmat");
	glUniformMatrix4fv(i,1,1,matrix);
	i=glGetUniformLocation(outer_shader,"time");
	//glUniform1f(i, (float)t*.00133);
	glUniform1f(i, 0);
	glScalef(50.f,50.f,50.f);
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3,GL_FLOAT, 3*sizeof(float), 0);
	glDrawArrays(GL_QUADS, 0, 6*4);
	glDisableClientState(GL_VERTEX_ARRAY);
	glDisable(GL_CULL_FACE);
	glDisable(GL_TEXTURE_CUBE_MAP);
}

#ifdef LINUX
int main() {
#else
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
//	void WINAPI WinMainCRTStartup() {
#endif
	int done=0, i;
	int slide_num=-1;
	float a=1,b=.01;
#ifdef LINUX
	SDL_Event event;
#else
	MSG msg;
#endif

	setup_graphics();
#ifndef LINUX
	load_gl_exts();
	ShowCursor(FALSE); 
#endif

	/* Textures */
	glGenTextures(1,&postprocess_texture);
	glBindTexture(GL_TEXTURE_2D,postprocess_texture);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,G_WIDTH, G_HEIGHT, 0,GL_RGB,GL_UNSIGNED_BYTE,0);
	cubemap = load_cubemap("data/n2n.png");
	title_texture = load_texture("data/title.png");
	init_slides();

	/* Bilinear filtern */
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	/* Buffer objects */
	bg_vbo = setup_vbo(square_vertices, 4*sizeof(TexturedVertexData3D));
	font_halves_vbo = setup_vbo(font_halves, 8*sizeof(TexturedVertexData3D));
	cube_vbo = setup_vbo(cube,72*sizeof(float)); 

	/* Initialize particles */
	glGenBuffers(1,&particle_vbo);
	glBindBuffer(GL_ARRAY_BUFFER, particle_vbo);
	glBufferData(GL_ARRAY_BUFFER, N_PARTICLES*6*sizeof(float), 0, GL_STREAM_COPY);
	particles = glMapBuffer(GL_ARRAY_BUFFER,GL_WRITE_ONLY);

	for(i=0; i<N_PARTICLES; i++) {
		particles[6*i]= my_float_rand() * 100.f - 100.f;
		particles[6*i+1]= my_float_rand() * 100.f - 100.f;
		particles[6*i+2]= my_float_rand() * 100.f+300.f;
		particles[6*i+3]= my_float_rand() * .1f;
		particles[6*i+4]= my_float_rand() * .1f;
		particles[6*i+5]= my_float_rand() * 12.f+12.f;
	}
	glUnmapBuffer(GL_ARRAY_BUFFER);


	/* Shaders */
	bg_shader=create_shader(vsh,NULL,bg_fsh);
	bobbel_shader=create_shader(vsh,billboard_gsh,bobbel_fsh);
	font_slide_shader=create_shader(slide_vsh,NULL,texgleam_fsh);
	inner_shader=create_shader(inner_vs,NULL,inner_fs);
	outer_shader=create_shader(outer_vs,NULL,outer_fs);
	postprocess_shader=create_shader(vsh,NULL,postproc_fsh);

	glClearDepth(200.f);
	glClearColor(0,0,0,1);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
#ifndef LINUX
	SwapBuffers(hDC);
	Sleep(1000);
#endif
	t=0;
	while(!done) {
#ifdef DUMP_VIDEO
		t+=1000/25;
#else
		/* TODO: inc t */
		t=SDL_GetTicks();
#endif
#ifndef LINUX
		PeekMessage( &msg, NULL, 0, 0, PM_REMOVE );
		TranslateMessage( &msg );
		DispatchMessage( &msg );
#endif


		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glAccum(GL_LOAD,1.f);

		//a = bezier_value(times,fade_bobbel,t);
		if(a>.001f) {
			bobble_scene();
			if(slide_num == -1) {
				glBindTexture(GL_TEXTURE_2D,title_texture);
				glide_in_font(0);
			}
			glAccum(GL_ACCUM,a); 
		}
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		if(a<.999f) {
			shadowmap_scene();
			glAccum(GL_ACCUM,1.f-a); 
		}

		if(a+b > 0.f && a+b<=1.f ) {
			a+=b;
		}

		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		glAccum(GL_RETURN,1.f);

		postprocess();

		if(slide_num >=0)
			draw_slide(slide_num);

#ifdef DUMP_VIDEO
		dump_frame(t);
#endif

		/* Push it all to the screen */
#ifdef LINUX
		SDL_GL_SwapBuffers();
#else
		SwapBuffers(hDC);
#endif

		/* Check for keypress */
#ifndef DUMP_VIDEO
#ifdef LINUX
		while( SDL_PollEvent(&event)|| SDL_GetTicks() < t + 20) {
			if(event.type==SDL_KEYDOWN) {
				switch(event.key.keysym.sym) {
					case SDLK_ESCAPE:
						done=1;
						break;
					case SDLK_SPACE:
					case SDLK_RIGHT:
						if(slide_num < N_SLIDES-1)
							slide_num++;
						break;
					case SDLK_LEFT:
						if(slide_num > 0)
							slide_num--;
						break;
					case 'e':
						b*=-1.f;
						break;
					case 's':
						strobotime=t;
						break;
					default:
						break;
				}
				event.type=0;
			}
			SDL_Delay(0);
		}
#else
		if(GetAsyncKeyState(VK_ESCAPE)) {
			done=1;
		}
		while(t < t+23) {
			Sleep(0);
		}
#endif
#endif

	}
#ifdef LINUX
	SDL_Quit();
	my_exit();
#else
	ExitProcess(0);
#endif
}
