static const char* bg_fsh="\
uniform float time;\
uniform vec4 col1,col2;\
void main()\
{\
	vec2 t=gl_TexCoord[0].xy;\
	gl_FragColor = mix(col1,col2,t.y)+col1*.3*pow(fract(1.-2.*time),3.);\
}";
static const char* vsh="\
void main()\
{\
	gl_Position = ftransform();\
	gl_FrontColor.xyz = gl_Normal;\
	gl_TexCoord[0] = gl_MultiTexCoord0;\
}";
static const char* slide_vsh="\
uniform float time;\
varying float s;\
void main() {\
	 s=1.;\
	 vec4 n=vec4(0.);\
	 n.x = gl_Normal.x*pow(abs(time),5.);\
	 gl_Position = gl_ModelViewProjectionMatrix * (gl_Vertex + n);\
	 gl_TexCoord[0] = gl_MultiTexCoord0;\
 }";
static const char* billboard_gsh="\
#version 120\n\
#extension GL_EXT_geometry_shader4 : enable\n\
uniform float time;\
\
void main(void)\
{\
	for(int i=0;i<gl_VerticesIn;i++)\
	{\
		/* float a=pow(fract(time),.3)*gl_FrontColorIn[i].z; */\
		float a=gl_FrontColorIn[i].z;\
		gl_Position    = gl_PositionIn[i]+vec4(.5*a,.5*a,0.,0.);\
		gl_TexCoord[0] = vec4(-1.0,-1.0,0,0);\
		EmitVertex();\
		gl_Position += vec4(-a,0.,0.,0.);\
		gl_TexCoord[0] = vec4(1.0,-1.0,0,0);\
		EmitVertex();\
		gl_Position += vec4(a,-a,0.,0.);\
		gl_TexCoord[0] = vec4(-1.0,1.0,0,0);\
		EmitVertex();\
		gl_Position += vec4(-a,0.,0.,0.);\
		gl_TexCoord[0] = vec4(1.0,1.0,0,0);\
		EmitVertex();\
	}\
}";
static const char* bobbel_fsh="\
void main()\n\
{\n\
	vec2 t=abs(gl_TexCoord[0].xy);\n\
	float p=.2;\n\
	float a=pow(1.-clamp(pow(t.x,2.)+pow(t.y,2.),0.,1.),p);\n\
	gl_FragColor = vec4(1.0,1.0,0.5,0.1)*a;\n\
}";
static const char* texgleam_fsh="\
uniform sampler2D t;\
varying float s;\
void main(){\
	vec4 c = texture2D(t,gl_TexCoord[0].xy);\
	if(c.a<.001) {discard;};\
	c+= 1.- clamp( pow(dot(vec4(3.,2.,1.,0.), gl_FragCoord), 4.),0.,1.);\
	gl_FragColor = c/clamp(s,0.,1000.);\
}";
static const char* inner_vs="\
varying vec3 pos;\
void main(void) {\
   gl_Position = ftransform();\
	 gl_TexCoord[0] = gl_MultiTexCoord0;\
   pos = gl_Vertex.xyz;\
 }";

static const char* inner_fs="\
varying vec3 pos;\
void main(void) {\
   gl_FragColor=vec4(1.5,1.5,1.5,1.)/dot(pos,pos);\
}";

static const char* outer_vs="\
varying vec4 pos;\
varying vec3 n;\
void main(void) {\
   gl_Position = ftransform();\
   pos = gl_ModelViewMatrix*gl_Vertex;\
   n = normalize(gl_NormalMatrix * gl_Normal);\
}";

static const char* outer_fs="\
varying vec4 pos;\
varying vec3 n;\
uniform float time;\
uniform vec4 lightpos;\
uniform mat4 rotmat;\
uniform samplerCube cube;\
void main(void) {\
	float a=pow(fract(1.-2.*time),3.);\
  vec4 c=vec4(1.,1.,2.1,1.0)*exp(-dot(pos,pos)/3000.);\
	c+=.1*vec4(1.,.8,.3,1.)*a;\
  c+=(80.+a*100.)/dot(pos-lightpos,pos-lightpos)*textureCube(cube,(rotmat*normalize(pos-lightpos)).xyz);\
  gl_FragColor=c;\
}";

static const char* postproc_fsh="\
uniform sampler2D t;\
void main(){\
  vec4 m=texture2D(t,gl_TexCoord[0].xy);\
  vec2 p=gl_TexCoord[0].xy;\
  vec2 n;\
  for (int i = -3; i < 3; i++) {\
          for(int j=-3;j<3;j++) {\
                  n.x = float(i)/800.;\
                  n.y = float(j)/600.;\
                  m += texture2D(t, p + n) * exp(-n.x*n.x-n.y*n.y)/100.;\
          }\
  }\
	m =m*.66 + pow(m,vec4(1.5))*.33;\
  m*=0.95+0.05*sin(p.y*1240.+5.*p.x);\
  p-=vec2(.5);p*=1.1;\
  m.a=0.4;\
	gl_FragColor=m*(1. - 10.*pow(pow(p.x*p.x,4.)+pow(p.y*p.y,4.),0.6));\
}";

